import { Injectable, ɵɵdefineInjectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxuiDatatableService {
    constructor() { }
}
NgxuiDatatableService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxuiDatatableService.ctorParameters = () => [];
/** @nocollapse */ NgxuiDatatableService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxuiDatatableService_Factory() { return new NgxuiDatatableService(); }, token: NgxuiDatatableService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxuiDatatableComponent {
    constructor() {
        this.clickEvent = new EventEmitter();
        this.order = true;
        this.currentSortKey = '';
        this.context = {};
    }
    /**
     * @return {?}
     */
    get headers() { return this.config.filter((/**
     * @param {?} item
     * @return {?}
     */
    item => item.schema !== false)); }
    /**
     * @return {?}
     */
    ngOnInit() {
        console.log(this.data);
        console.log(this.config);
    }
    /**
     * @param {?} array
     * @return {?}
     */
    checkOrder(array) {
        if (!this.order) {
            array.reverse();
        }
        return array;
    }
    /**
     * @param {?} key
     * @return {?}
     */
    sort(key) {
        /** @type {?} */
        const dataClone = [...this.data];
        dataClone.sort((/**
         * @param {?} x
         * @param {?} y
         * @return {?}
         */
        (x, y) => (x[key] > y[key]) ? 1 : -1));
        this.data = [...this.checkOrder(dataClone)];
    }
    /**
     * @param {?} header
     * @return {?}
     */
    sortBy(header) {
        if (header === this.currentSortKey) {
            this.order = !this.order;
        }
        this.currentSortKey = header;
        this.sort(header);
    }
    /**
     * @param {?} name
     * @return {?}
     */
    sortedBy(name) {
        console.log(this.currentSortKey === name || false);
    }
    /**
     * @param {?} name
     * @return {?}
     */
    sortHandler(name) {
        this.sortBy(name);
    }
    /**
     * @param {?} eventKey
     * @param {?} eventObject
     * @return {?}
     */
    emitActionEvent(eventKey, eventObject) {
        /** @type {?} */
        const event = {
            key: eventKey,
            object: eventObject
        };
        this.clickEvent.emit(event);
    }
}
NgxuiDatatableComponent.decorators = [
    { type: Component, args: [{
                // tslint:disable-next-line: component-selector
                selector: 'ngxui-datatable',
                template: "<table class=\"ngxui-datatable\">\n    <thead class=\"ngxui-datatable__header\">\n        <tr class=\"ngxui-datatable__tr\">\n            <ng-container *ngFor=\"let header of headers\">\n                <lib-table-header [name]=\"header.name\" [sortKey]=\"currentSortKey\" (emitSortClick)=\"sortHandler($event)\">\n                </lib-table-header>\n            </ng-container>\n\n            <ng-container *ngFor=\"let action of actions.items\">\n                <lib-table-header [name]=\"action.name\" [sortKey]=\"currentSortKey\" (emitSortClick)=\"sortHandler($event)\">\n                </lib-table-header>\n            </ng-container>\n\n        </tr>\n    </thead>\n    <tbody class=\"ngxui-datatable__body\">\n        <tr class=\"ngxui-datatable__tr\" *ngFor=\"let row of data\">\n            <ng-container *ngFor=\"let header of headers\">\n                <td class=\"ngxui-datatable__td\">\n                    <ng-container *ngIf=\"header.link; else second\">\n                        <a href=\"{{ row[header.name] }}\">Link</a>\n                    </ng-container>\n                    <ng-template #second>{{ row[header.name] }}</ng-template>\n                </td>\n            </ng-container>\n            <td class=\"ngxui-datatable__td ngxui-datatable__actions\" *ngIf=\"actions\">\n                <button class=\"ngxui-datatable__button\" (click)=\"emitActionEvent(action.key, row)\"\n                    *ngFor=\"let action of actions.items\">{{ action.name }}</button>\n            </td>\n        </tr>\n    </tbody>\n</table>\n",
                styles: ["@charset \"UTF-8\";:host ::ng-deep .ngxui-datatable{position:relative;width:100%;border-collapse:collapse;overflow:hidden;word-break:normal;word-break:keep-all;color:#53545a;border:1px solid #dddee4;font-size:14px}:host ::ng-deep .ngxui-datatable__header{text-transform:uppercase;text-align:left;font-weight:600;background-color:#4d4d4d;color:#fff;border-top:1px solid #dddee4;box-shadow:0 0 5px 0 rgba(128,128,128,.15);margin:1rem 0}:host ::ng-deep .ngxui-datatable__td,:host ::ng-deep .ngxui-datatable__th{position:relative}:host ::ng-deep .ngxui-datatable__tr{background-color:transparent;border-bottom:1px solid #dddee4}:host ::ng-deep .ngxui-datatable__th{border:1px solid rgba(0,0,0,.12);padding:1rem .75rem}:host ::ng-deep .ngxui-datatable__th:after{content:\"\u25BF\";position:absolute;right:2rem;top:50%;-webkit-transform:translateY(-50%);transform:translateY(-50%)}:host ::ng-deep .ngxui-datatable__td{border:1px solid rgba(0,0,0,.12);padding:.5rem}:host ::ng-deep .ngxui-datatable__button{padding:.25rem;background-color:coral;border-color:#ff6c37;color:#fff}"]
            }] }
];
/** @nocollapse */
NgxuiDatatableComponent.ctorParameters = () => [];
NgxuiDatatableComponent.propDecorators = {
    config: [{ type: Input }],
    data: [{ type: Input }],
    templates: [{ type: Input }],
    actions: [{ type: Input }],
    clickEvent: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    NgxuiDatatableComponent.prototype.config;
    /** @type {?} */
    NgxuiDatatableComponent.prototype.data;
    /** @type {?} */
    NgxuiDatatableComponent.prototype.templates;
    /** @type {?} */
    NgxuiDatatableComponent.prototype.actions;
    /** @type {?} */
    NgxuiDatatableComponent.prototype.clickEvent;
    /** @type {?} */
    NgxuiDatatableComponent.prototype.order;
    /** @type {?} */
    NgxuiDatatableComponent.prototype.currentSortKey;
    /** @type {?} */
    NgxuiDatatableComponent.prototype.context;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class TableHeaderComponent {
    constructor() {
        this.emitSortClick = new EventEmitter();
        this.toggled = false;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
    /**
     * @param {?} name
     * @return {?}
     */
    clickHeader(name) {
        this.toggled = !this.toggled;
        this.emitSortClick.emit(name);
    }
    /**
     * @return {?}
     */
    issort() {
        return this.toggled && this.name === this.sortKey;
    }
}
TableHeaderComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-table-header',
                template: "<div class=\"ngxui-datatable__th\" (click)=\"clickHeader(name)\" [class.ngxui-datatable--active]=\"issort()\">\n    <span>{{ name }}</span>\n</div>\n",
                styles: [":host{text-align:-internal-center;display:table-cell;vertical-align:inherit;font-weight:700}:host--active{-webkit-transform:rotate(180deg);transform:rotate(180deg)}"]
            }] }
];
/** @nocollapse */
TableHeaderComponent.ctorParameters = () => [];
TableHeaderComponent.propDecorators = {
    name: [{ type: Input }],
    sortKey: [{ type: Input }],
    emitSortClick: [{ type: Output }]
};
if (false) {
    /** @type {?} */
    TableHeaderComponent.prototype.name;
    /** @type {?} */
    TableHeaderComponent.prototype.sortKey;
    /** @type {?} */
    TableHeaderComponent.prototype.emitSortClick;
    /** @type {?} */
    TableHeaderComponent.prototype.toggled;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxuiDatatableModule {
}
NgxuiDatatableModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxuiDatatableComponent, TableHeaderComponent],
                imports: [
                    CommonModule
                ],
                exports: [NgxuiDatatableComponent]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxuiDatatableComponent, NgxuiDatatableModule, NgxuiDatatableService, TableHeaderComponent as ɵa };
//# sourceMappingURL=ngxui-datatable.js.map
